#if !defined(TOKEN_HH)
#define TOKEN_HH

#include <string>

using std::string;

///////////////////////////////////////////////////////////////////////////
class Token {
///////////////////////////////////////////////////////////////////////////
  
public :
  
  enum PosClass {
    NIL,
    EOFF,
    NUMBER,
    OPERATOR,
    LPAR,
    RPAR
  };

  Token( void ) : pos_(NIL), lexeme_("") { }
  Token( PosClass pos, string lexeme ) : pos_(pos), lexeme_(lexeme) { }
  ~Token( void ) { }

  void setPartOfSpeech( PosClass pos ) { pos_ = pos; }
  void setLexeme( const string& lexeme ) { lexeme_ = lexeme; }

  int getPartOfSpeech( void ) const { return pos_; }
  const string& getLexeme( void ) const { return lexeme_; }

private :
  int    pos_;
  string lexeme_;

}; // End of class Token

#endif
